package events

import (
	"fmt"
	"sync"

	"github.com/zjxpcyc/tinyevent"
)

var mtx sync.Mutex

// EvtActions 内置 Action 列表
var EvtActions = map[string]tinyevent.Action{
	// 测试
	ActTest: tsAction,

	// 赠送卡券
	ActGiveCoupon: giveCoupon,
}

// ListenAllEvent 监听所有事件
func ListenAllEvent() {
	mtx.Lock()
	defer mtx.Unlock()

	// // 所有需要执行的事件
	// allEvts, err := getAllEvents()
	// if err != nil {
	// 	utils.LogError(err)
	// }

	// // 刷新中控中心
	// utils.ResetEvtBus()

	// for evt, acts := range allEvts {
	// 	for _, actKey := range acts {
	// 		act, ok := EvtActions[actKey]
	// 		if ok {
	// 			utils.ListenEvent(evt, act)
	// 		}
	// 	}
	// }
}

// getAllEvents 获取数据库配置
func getAllEvents() (map[string][]string, error) {
	// db := models.DBEngine

	// var evts []model.SysActivity
	// if err := db.Where("status=?", models.STATUS_NORMAL).Find(&evts); err != nil {
	// 	return nil, err
	// }

	// TODO
	return map[string][]string{
		EvtRegiste: []string{
			ActTest,
			ActGiveCoupon,
		},
	}, nil
}

var tsAction = func(e tinyevent.Event) error {
	str := e.Payload.(string)
	fmt.Println(str)
	return nil
}
